#
# Recipe for building zlib, libpng, libjpeg, and libtiff from source.
# This worked for me using MSYS/MinGW on Windows 2003 on a Tuesday.
# Your mileage may vary.
#

set -e		;# exit on error

#
# The 'prefix' variable is used to specify where third-party libraries
# are installed.
#

prefix=/tmp/img-extlibs

#
# Build zlib:
#
(
    cd zlib-1.2.1 
    sh configure --prefix=$prefix
    make 
    make install
)

#
# Build libpng:
#

(
    cd libpng-1.2.8-config
    CPPFLAGS=-I${prefix}/include LDFLAGS=-L${prefix}/lib \
	sh configure --disable-shared --prefix=$prefix
    make
    make install
)

#
# Build libjpeg:
#
(
    cd jpeg-6b
    sh configure --prefix=$prefix
    make
    make install-lib
)

#
# Build libtiff:
#
(
    cd tiff-3.7.0
    CPPFLAGS=-I${prefix}/include LDFLAGS=-L${prefix}/lib \
	sh configure --disable-shared --prefix=$prefix
    make
    # run 'make install' in the libtiff subdirectory;
    # don't need to install everything
    cd libtiff
    make install
)


#
# Finally, build the Img package, using the libraries built
# in the previous steps:
#

mkdir -p img
cd img
CPPFLAGS=-I${prefix}/include LDFLAGS=-L${prefix}/lib \
    sh ../../configure
make

