/*
 * imgInit.c
 */

#include <tk.h>

#include "tkimg.h"

extern int Tkimgpng_Init(Tcl_Interp *);
extern int Tkimgjpeg_Init(Tcl_Interp *);
extern int Tkimgtiff_Init(Tcl_Interp *);
extern int Tkimgps_Init(Tcl_Interp *);
extern int Tkimgtga_Init(Tcl_Interp *);
extern int Tkimgxbm_Init(Tcl_Interp *);
extern int Tkimgxpm_Init(Tcl_Interp *);
extern int Tkimgpcx_Init(Tcl_Interp *);
extern int Tkimgppm_Init(Tcl_Interp *);		/* ??? Needed ??? */
extern int Tkimggif_Init(Tcl_Interp *);		/* ??? Needed? Y: string fmt*/
extern int Tkimgbmp_Init(Tcl_Interp *);
extern int Tkimgico_Init(Tcl_Interp *);
extern int Tkimgsgi_Init(Tcl_Interp *);
extern int Tkimgsun_Init(Tcl_Interp *);
extern int Tkimgwindow_Init(Tcl_Interp *);

static Tcl_AppInitProc *subpackages[] = {
    Tkimgpng_Init,
    Tkimgjpeg_Init,
    Tkimgtiff_Init,
    Tkimgps_Init,
    Tkimgtga_Init,
    Tkimgxbm_Init,	/* @@@ Must precede xpm_init -- why?!? */
    Tkimgxpm_Init,
    Tkimgpcx_Init,
    Tkimgppm_Init,
    Tkimggif_Init,
    Tkimgbmp_Init,
    Tkimgico_Init,
    Tkimgsgi_Init,
    Tkimgsun_Init,
    Tkimgwindow_Init,
    0
};

extern Tk_ImageType		imgPixmapImageType;

/*
 * The variable "initialized" may or may not still be needed ...
 */

static int initialized = 0;

/*
 *--------------------------------------------------------------
 *
 * Img_Init , Img_SafeInit, Img_InitStandAlone --
 *	Create Img commands.
 *
 */

DLLEXPORT int Img_Init(Tcl_Interp *interp)
{
    Tcl_AppInitProc **subpackage;

    if (Tcl_InitStubs(interp, TCL_VERSION, 0) == NULL) {
	return TCL_ERROR;
    }
    if (Tk_InitStubs(interp, TK_VERSION, 0) == NULL) {
	return TCL_ERROR;
    }

    for (subpackage = subpackages; *subpackage; ++subpackage) {
	if ((*subpackage)(interp) != TCL_OK) {
	    return TCL_ERROR;
	}
    }

    if (!initialized) {
#if NYI
	Tk_CreateImageType(&imgPixmapImageType);
#endif
    }

    return Tcl_PkgProvide(interp,"Img", TKIMG_VERSION);
}

DLLEXPORT int Img_SafeInit(Tcl_Interp *interp)
{
    return Img_Init(interp);
}

