#
# Interactive test for Img package:
#

set auto_path [linsert $auto_path 0 .]

package require Tk
package require Img

puts "Loaded Img [package ifneeded Img [package require Img]]"

set imgdir [file dirname [info script]]

if {[llength $argv] == 1} { set imgdir [lindex $argv 0] }

scrollbar .vsb -command [list .t yview] -orient vertical
text .t -yscrollcommand [list .vsb set]
grid .t .vsb  -sticky news
grid columnconfigure . 0 -weight 1
grid rowconfigure . 0 -weight 1

set i 0
set imgfiles [lsort [concat \
    [glob -nocomplain -type f -directory $imgdir *] \
    [glob -nocomplain -type f -directory $imgdir/images *] ]]

foreach file $imgfiles {
    if {[lsearch {.tcl .test} [file extension $file]] != -1} {
    	continue
    }

    puts "Loading $file"
    set imgname [file tail $file]
    if {[catch { image create photo $imgname -file $file } msg]} {
	.t insert end "\nSkipping $file: $msg\n"
	continue
    }
    .t window create end -window [label .t.l$i \
    	-compound top -text [file tail $file] -image $imgname]

    incr i
}

#
# Interactive test for window image type:
#

image create photo snapshot
proc take.snapshot {} { 
    snapshot blank; 
    snapshot put . -format window 
}

.t insert end "\n"
.t window create end -window [button .t.bsnap \
    -compound bottom -text "Press me" -image snapshot -command take.snapshot]
.t insert end "\n"


